/* Matei MACRI
 * 332 CA
 * PM 2014
 */

#include <stdlib.h>
#include <avr/interrupt.h>
#include <util/delay.h>

void ADC_init(void){ 
	ADCSRA |= ((1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0));// prescaler 128
	ADMUX |= (1<<REFS0);// referinta la VCC
	ADCSRA |= (1<<ADEN);// enable
	ADCSRA |= (1<<ADSC);// porneste prima conversie
}

int read_distance_sensor(void){
	ADCSRA |= (1<<ADSC);// da drumul la conversie
	while(!bit_is_set(ADCSRA,ADIF));//asteapta terminarea conversiei
	return ADCW;
}

void PWM_init(void)
{
	// fast PWM cu prag pe ICR1 => WGM13, WGM12 si WGM11 sunt 1
	// mod non-inverting => COM1A1 = 1
	// prescaler 256 => CS12
	TCCR1A |= (1 << WGM11) | (1 << COM1A1) | (1 << COM1B1);
	TCCR1B |= (1 << WGM13) | (1 << WGM12) | (1 << CS12);
	ICR1 = 512;
	// PWM default cu factor umplere 50%
	OCR1A = 256;
	OCR1B = 256;
}

void evasion_protocol(void)
{
	// Hard left for t
	OCR1A = 270;
	OCR1B = 128;
	_delay_ms(1000);
	// Hard right for 1.75*t
	OCR1A = 128;
	OCR1B = 270;
	_delay_ms(1750);
	// in acest mom, robotul vine aproape perpendicular pe linie
	// since that would cause problems, we redress our course with a final
	// Hard left for 0.5*t
	OCR1A = 270;
	OCR1B = 128;
	_delay_ms(500);
}

int main(void)
{
	ADC_init();
	PWM_init();
	// toate porturile deschise :D
	DDRD = (1 << PD1) | (1 << PD2) | (1 << PD3) | (1 << PD4) | (1 << PD5) | (1 << PD6) | (1 << PD7);
	PORTD |= (1 << PD1);//STDBY pe H
	PORTD |= (1 << PD7);//AIN1 pe H (clockwise rotation)
	PORTD |= (1 << PD3);//BIN1 pe H

	while(1)
	{
		if(read_distance_sensor() > 400)
			evasion_protocol();
		// PINB 0-3 -> dreapta
		// PINC 1-4 -> stanga
		// motorul A pe stanga, motorul B pe dreapta
		// ca sa carmesc la stanga, dau mai multa putere (aka factor umplere) motorului din dreapta
		if(PINB & (1 << PB0))
			OCR1A = 270;
		else if(PINB & (1 << PB1))
			OCR1A = 200;
		else if(PINB & (1 << PB2))
			OCR1A = 160;
		else
			OCR1A = 128;
		if(PINC & (1 << PC4))
			OCR1B = 270;
		else if(PINC & (1 << PC3))
			OCR1B = 200;
		else if(PINC & (1 << PC2))
			OCR1B = 160;
		else
			OCR1B = 128;
	}

	return 0;
}
